/* lqversion.c -- Copyright 1993 Liam R. Quin.  All Rights Reserved.
 * This code is NOT in the public domain.
 * See the file COPYRIGHT for full details.
 */

#ifndef LINT
static char *RcsId = "@(#) $Id: lqrversion.c,v 1.1 93/11/28 15:16:11 lee Exp $";
#endif

#include "globals.h" /* defines and declarations for database filenames */
#include <stdio.h>
#include "error.h"

#include "Revision.h"
#include "blkheader.h"
#include "block0.h"

extern char *ReadBlock();
extern void WriteBlock();

static char *
lqFlagString(byte)
    unsigned char byte;
{
    if ((byte & 01) == 0) {
	return "[unknown, or flags corrupt]";
    }
    if (byte & 02) {
	return "-DWIDINBLOCK";
    } else {
	return "-UWIDIINBLOCK";
    }
}

API void
lqCheckVersion()
{
    int MajorVersion;
    int MinorVersion;
    unsigned char *p;

    p = (unsigned char *) ReadBlock(0L);

    if (*p == 0) {
	lqWriteVersion();
	return;
    }

    if (p[BLOCK_ZERO_COMPILEFLAGBYTE] != LQ_FLAG_VALUE) {
	Error(E_FATAL,
	    "Mismatch: Database flags %d [%s] compiled %d [%s]",
	    (int) *p,
	    lqFlagString(*p),
	    LQ_FLAG_VALUE,
	    lqFlagString(LQ_FLAG_VALUE)
	);
    }
    MajorVersion = (
	(unsigned char) p[BLOCK_ZERO_MAJORVERSION0]) * 256 +
	(unsigned char) p[BLOCK_ZERO_MAJORVERSION1];
    MinorVersion = p[BLOCK_ZERO_MINORVERSION];

    if (MajorVersion != LQ_MAJOR_VERSION || MinorVersion != LQ_MINOR_VERSION) {
	Error(E_FATAL,
	    "Database was written with lqtext %d.%d, %d.%d can't read it",
	    MajorVersion, MinorVersion, LQ_MAJOR_VERSION, LQ_MINOR_VERSION
	);
    }
}

